<template>
    <div class="flex items-end justify-between mb-4">
        <div class="flex items-end gap-3">
            <div class="form-control">
                <div class="text-sm">Từ khóa:</div>
                <label for="keyword">
                    <input
                        @keyup="search"
                        v-model="keyword"
                        id="keyword"
                        type="text"
                        class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                        placeholder="Từ khóa..."
                        autocomplete="off"
                    />
                </label>
            </div>
            <BasicButton
                @click="search"
                classCustom="bg-color-warning hover:shadow-hover-warning"
            >
                <SearchIcon class="text-white" />
                <span>Tìm kiếm</span>
            </BasicButton>
        </div>
        <div class="flex items-end gap-3">
            <LinkButton
                nameRoute="teacher-test-create"
                :paramsRoute="{
                    courseId: course ? course.id : $route.params.courseId
                }"
                classCustom="bg-color-success hover:shadow-hover-success"
            >
                <PlusCircleIcon class="text-white" />
                <span>Thêm bài kiểm tra</span>
            </LinkButton>
            <LinkButton
                nameRoute="teacher-lesson-create"
                :paramsRoute="{
                    courseId: course ? course.id : $route.params.courseId
                }"
            >
                <PlusCircleIcon class="text-white" />
                <span>Thêm bài học</span>
            </LinkButton>
        </div>
    </div>

    <table>
        <thead>
            <tr>
                <th>Thông tin khóa học</th>
                <th class="text-center">Sắp xếp</th>
                <th>Thời gian tạo</th>
                <th class="text-center">Hành động</th>
            </tr>
        </thead>
        <tbody>
            <template v-if="lessonsComputed && lessonsComputed.length">
                <tr :key="lesson.id" v-for="lesson in lessonsComputed">
                    <td class="max-w-2xl">
                        <div class="flex gap-3">
                            <img
                                :src="
                                    lesson.image
                                        ? lesson.image
                                        : require('@/assets/images/no-image.webp')
                                "
                                class="w-28 min-w-28 h-full"
                                alt=""
                            />
                            <div>
                                <div class="text-lg font-semibold">
                                    {{ lesson.name }}
                                </div>
                                <div
                                    v-if="lesson.test"
                                    class="box-actions flex items-center gap-1"
                                >
                                    <span class="text-gray-600">
                                        Bài kiểm tra: {{ lesson.test.name }}
                                    </span>
                                    <router-link
                                        :to="{
                                            name: 'teacher-test-update',
                                            params: {
                                                courseId: course.id,
                                                testId: lesson.test.id
                                            }
                                        }"
                                        v-tooltip="'Sửa'"
                                        class="action-edit"
                                    >
                                        <PencilIcon class="w-4 h-4" />
                                    </router-link>
                                    <div
                                        @click="
                                            onRemoveTest(
                                                lesson.id,
                                                lesson.test.id
                                            )
                                        "
                                        v-tooltip="'Xóa'"
                                        class="cursor-pointer action-delete"
                                    >
                                        <TrashIcon class="w-4 h-4" />
                                    </div>
                                </div>
                                <p
                                    class="line-clamp-3"
                                    v-html="lesson.description"
                                ></p>
                            </div>
                        </div>
                    </td>
                    <td class="text-center">{{ lesson.order }}</td>
                    <td>{{ lesson.created_at }}</td>
                    <td>
                        <div
                            class="box-actions flex items-center justify-center gap-1"
                        >
                            <router-link
                                :to="{
                                    name: 'teacher-lesson-update',
                                    params: {
                                        courseId: course.id,
                                        lessonId: lesson.id
                                    }
                                }"
                                v-tooltip="'Sửa'"
                                class="action-edit"
                            >
                                <PencilIcon />
                            </router-link>
                            <div
                                @click="onRemoveLesson(lesson.id)"
                                v-tooltip="'Xóa'"
                                class="cursor-pointer action-delete"
                            >
                                <TrashIcon />
                            </div>
                        </div>
                    </td>
                </tr>
            </template>
            <template v-else>
                <tr class="no-data-table">
                    <td colspan="6" class="text-center">
                        Không có dữ liệu
                    </td>
                </tr>
            </template>
        </tbody>
    </table>
</template>

<script>
import { computed, ref } from "vue";
import { useRoute, useRouter } from "vue-router";
import timeHelper from "@/helper/timeHelper";
import Swal from "sweetalert2";
import { createToast } from "mosha-vue-toastify";

import useDeleteLesson from "@/hooks/lesson/useDeleteLesson";
import useDeleteTest from "@/hooks/test/useDeleteTest";

import {
    SearchIcon,
    PlusCircleIcon,
    PencilIcon,
    TrashIcon
} from "@heroicons/vue/outline";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";

export default {
    components: {
        SearchIcon,
        PlusCircleIcon,
        PencilIcon,
        TrashIcon,
        BasicButton,
        LinkButton
    },
    props: {
        course: {
            type: Object,
            required: true
        }
    },
    setup(props) {
        const route = useRoute();
        const router = useRouter();
        const keyword = ref(route.query.keyword || null);
        const lessons = ref(props.course.lessons);
        const { errorResponse, onDeleteLesson } = useDeleteLesson();
        const { errorResponseTest, onDeleteTest } = useDeleteTest();

        const lessonsComputed = computed(() => {
            if (lessons.value && lessons.value.length) {
                return lessons.value.map(lesson => {
                    return {
                        ...lesson,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(lesson.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        function search() {
            let keywordSearch = keyword.value.toLowerCase();

            router.push({
                path: route.path,
                query: { keyword: keyword.value },
                hash: route.hash
            });

            lessons.value = props.course.lessons.filter(lesson => {
                if (
                    lesson.name &&
                    lesson.name.toLowerCase().indexOf(keywordSearch) >= 0
                ) {
                    return true;
                }
                if (
                    lesson.description &&
                    lesson.description.toLowerCase().indexOf(keywordSearch) >= 0
                ) {
                    return true;
                }
                return false;
            });
        }

        // delete lesson
        async function onRemoveLesson(id) {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn có chắc muốn xóa bài học này không?</span>`,
                confirmButtonText: "Xóa",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    // show loading
                    document.getElementById("full-page-loading").style.display =
                        "block";

                    await onDeleteLesson(id);

                    // hide loading
                    document.getElementById("full-page-loading").style.display =
                        "none";

                    // check error from server
                    if (errorResponse.value) {
                        createToast("Xóa thất bại, đã có lỗi xảy ra", {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        lessons.value = lessons.value.filter(lesson => {
                            return lesson.id != id;
                        });
                        createToast("Xóa bài học thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        async function onRemoveTest(lessonId, testId) {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn có chắc muốn xóa bài kiểm tra này không?</span>`,
                confirmButtonText: "Gửi",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    // show loading
                    document.getElementById("full-page-loading").style.display =
                        "block";

                    await onDeleteTest(testId);

                    // hide loading
                    document.getElementById("full-page-loading").style.display =
                        "none";

                    // check error from server
                    if (errorResponseTest.value) {
                        createToast(errorResponseTest.value, {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        lessons.value = lessons.value.map(lesson => {
                            return {
                                ...lesson,
                                test:
                                    lesson.id === lessonId ? null : lesson.test
                            };
                        });
                        createToast("Xóa bài kiểm tra thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        return {
            keyword,
            lessonsComputed,
            search,
            onRemoveLesson,
            onRemoveTest
        };
    }
};
</script>
